/**
 * This service relies on a copy of the File Sharing service.
 * Its serverScripts/ templates/ and public_html/ directories are an svn cp of the corresponding directories in File Sharing, avoid at all costs to change the files contained in those directories so that we can easily merge new versions of the File Sharing service into this one.
 */
function webserver( connection, data )
{
    var ROOT_PATH = '/shared';
    var indexes =
    [
        'index.html',
        'index.htm'/*,
        'default.html',
        * 
        'default.htm',
        'welcome.html',
        'welcome.htm'*/
    ];
    var filePath = ROOT_PATH + connection.request.path;
    var files = Yusef.mountpoints.shared.resolve( filePath );
    var indexFile;
    //var _activityStream = new ActivityStream();
    
    // find a possible index file if the path in the request is a directory
    if( files.exists)
    {
        if (files.isDirectory)
        {
            files.refresh();
            for( var i = 0, index; index = indexes[i]; i++ )
            {
                if( (file = files.resolve( index )).exists )
                {
                    indexFile = file;
                    break;
                }
            }
        }
        else
        {
            var fileName        = files.path.replace(/^\/shared\//, "");
            var fullPath        = opera.io.webserver.currentServicePath+'content/' + fileName;
            var fullPathAbsolute = 'http://'+connection.request.headers.Host[0] + fullPath;
            
            //_activityStream.publish("File " + fileName + " was viewed", ActivityVerbType.View,
            //new ActivityObjectModel(ActivityObjectType.File, fileName, fullPathAbsolute), null);
        }
    }
	    
    data.message = "";
	
	if( connection.isOwner )
    {
        if( !indexFile && getQueryItem( 'create_index' ) == 'true' )
        {
            indexFile = createIndex();
        }
        
        // sets data.message about index files sent to users
        var messagesData = { index: (indexFile||{}).name };
		//if ( data.fileNotExists ) messagesData.fileNotExists = true;
        var messages = new Markuper( 'templates/messages.html', messagesData );
        var messageId = indexFile ? '#messageHasIndexFile' : '#messageNoIndexFile';
        
        data.message = ( !data.fileNotExists )?messages.select(messageId).parse():'';
    }
    else if( indexFile )
    {
        return indexFile;
    }
    
    function getQueryItem( name )
    {
        return (connection.request.queryItems[name]||[])[0];
    }
    
    function createIndex()
    {
        var indexName = indexes[0];
        var tmpl = new Markuper( 'templates/index.html' );
        var translator = new Translator({domain : 'service'});
        var file = Yusef.mountpoints.shared.resolve( ROOT_PATH + connection.request.path + '/' + indexName );
        var fs = file.open( file, 'w' );
        
        translator.setLanguagesFromHttp( connection );
        fs.write( translator.translate(tmpl.html()) );
        fs.close();
        
        return file;
    }
}